import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type {
  CompanyField,
  CompanyFieldParam
} from '@/api/oa/company/field/model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询客户资料
 */
export async function pageCompanyField(params: CompanyFieldParam) {
  const res = await request.get<ApiResult<PageResult<CompanyField>>>(
    MODULES_API_URL + '/oa/company-field/page',
    {
      params
    }
  );
  console.log(res.data.data);
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询客户资料列表
 */
export async function listCompanyField(params?: CompanyFieldParam) {
  const res = await request.get<ApiResult<CompanyField[]>>(
    MODULES_API_URL + '/oa/company-field',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询客户资料
 */
export async function getCompanyField(id: number) {
  const res = await request.get<ApiResult<CompanyField>>(
    MODULES_API_URL + '/oa/company-field/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加客户资料
 */
export async function addCompanyField(data: CompanyField) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/company-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改客户资料
 */
export async function updateCompanyField(data: CompanyField) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/company-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除客户资料
 */
export async function removeCompanyField(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/company-field/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除客户资料
 */
export async function removeBatchCompanyField(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/company-field/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/company-field/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
